package fr.username404.snowygui

import fr.username404.snowygui.EventSnowy.Companion.useKey
import fr.username404.snowygui.config.Configuration.obtained
import fr.username404.snowygui.misc.AddKeyMaps
import io.github.config4k.getValue
import org.apache.logging.log4j.LogManager
import org.apache.logging.log4j.Logger
import org.reflections8.Reflections
import org.reflections8.scanners.SubTypesScanner
import org.reflections8.scanners.TypeAnnotationsScanner
import org.reflections8.util.ClasspathHelper
import org.reflections8.util.ConfigurationBuilder

abstract class Snowy {
    private val displayInitMessage: Boolean by obtained
    companion object {
        val reflections = Reflections(ConfigurationBuilder()
            .setUrls(ClasspathHelper.forClassLoader())
            .setScanners(SubTypesScanner(false), TypeAnnotationsScanner())
            .useParallelExecutor()
        )
        fun onEvent(e: String, lambda: argsLambda) = useKey(e).add(lambda)
        @JvmField
        val logs: Logger = LogManager.getLogger()
        init {
            reflections.allTypes.forEach {
                if (it.contains("fr.username404")) logs.info(it)
            }
        }
    }
    private fun eventsInit() {
        onEvent("EndTick") {
            for (Key in AddKeyMaps.list.keys) {
                if (Key.isDown) {
                    AddKeyMaps.list[Key]?.invoke()
                }
            }
        }
    }
    fun atInit() {
        if (displayInitMessage) logs.info("Init point of SnowyGUI hit.")
        eventsInit()
    }
}